package calculate;

import java.util.ArrayList;
import java.util.List;

import main.Complex;
import main.GeneMatch;
import main.GraphEntropy;

public abstract class ModelOfEvaluate {
	
	
	
	
	public abstract double getMatchValue(ModelOfEvaluate EM, int flag);
	
	public abstract List<Double> getList();
	
	
	public static double calPingFangCha(ModelOfEvaluate em1, ModelOfEvaluate em2){
		List<Double> l1 = em1.getList();
		List<Double> l2 = em2.getList();
		
		double sum = 0.0;
		for(int i = 0; i < l1.size(); i++){
			double pfc = Math.pow(l1.get(i) - l2.get(i), 2);
			sum += pfc;
		}
		
		return sum;
	}
	public static double calMyMethod(ModelOfEvaluate em1, ModelOfEvaluate em2){
		List<Double> l1 = em1.getList();
		List<Double> l2 = em2.getList();
		
		double sum = 0;
		for(int i = 0; i < l1.size(); i++){
			double v;
			double v1 = l1.get(i);
			double v2 = l2.get(i);
			if(v1 - v2 == 0){
				 v = 200;
			} else {
				 v = (Math.abs(v1) + Math.abs(v2)) / Math.abs(v1 - v2);
			}
//			sum += GraphEntropy.log(2, v);
			sum += GraphEntropy.ln(v);
		}
		
		return sum;
	}
	public static double calMyEntropy(ModelOfEvaluate em1, ModelOfEvaluate em2){
		List<Double> l1 = em1.getList();
		List<Double> l2 = em2.getList();
		
		double sum = 0;
		for(int i = 0; i < l1.size(); i++){
			double v1 = l1.get(i);
			double v2 = l2.get(i);
			double v = (Math.abs(v1) - Math.abs(v2)) / (Math.abs(v1) + Math.abs(v2));
			sum += GraphEntropy.getGraphEntropy(v);
		}
		
		return sum;
	}
	public static double calPearson(ModelOfEvaluate em1, ModelOfEvaluate em2){
		List<Double> l1 = em1.getList();
		List<Double> l2 = em2.getList();
		
		int n = l1.size();
		double sum1 = 0;
		double sum2 = 0;
		double fangcha1 = 0;
		double fangcha2 = 0;
		double xiefangcha = 0.0;
		
		for(int i = 0; i < l1.size(); i++){
			double v1 = l1.get(i);
			double v2 = l2.get(i);
			sum1 += v1;
			sum2 += v2;
		}
		
		sum1 = sum1 / n;
		sum2 = sum2 / n;
		for(int i = 0; i < l1.size(); i++){
			double v1 = l1.get(i);
			double v2 = l2.get(i);
			fangcha1 += (v1 - sum1) * (v1 - sum1);
			fangcha2 += (v2 - sum2) * (v2 - sum2);
			xiefangcha += (v1 - sum1) * (v2 - sum2);
		}
		//System.out.println(xiefangcha / (Math.sqrt(fangcha1) * Math.sqrt(fangcha2)) + "-" + xiefangcha + "--" + Math.sqrt(fangcha1) + "==" + Math.sqrt(fangcha2));
		return xiefangcha / (Math.sqrt(fangcha1) * Math.sqrt(fangcha2));
	}
	public static double calPearsonBase(List<Double> l1, List<Double> l2){
		
		int n = l1.size();
		double sum1 = 0;
		double sum2 = 0;
		double fangcha1 = 0;
		double fangcha2 = 0;
		double xiefangcha = 0.0;
		
		for(int i = 0; i < l1.size(); i++){
			double v1 = l1.get(i);
			double v2 = l2.get(i);
			sum1 += v1;
			sum2 += v2;
		}
		
		sum1 = sum1 / n;
		sum2 = sum2 / n;
		for(int i = 0; i < l1.size(); i++){
			double v1 = l1.get(i);
			double v2 = l2.get(i);
			fangcha1 += (v1 - sum1) * (v1 - sum1);
			fangcha2 += (v2 - sum2) * (v2 - sum2);
			xiefangcha += (v1 - sum1) * (v2 - sum2);
		}
		//System.out.println(xiefangcha + "---" + Math.sqrt(fangcha1) * Math.sqrt(fangcha2) + "==" + Math.sqrt(fangcha2));
		return xiefangcha / (Math.sqrt(fangcha1) * Math.sqrt(fangcha2));
	}
	
	
	public static double calAllPingFanCha(List<GeneMatch> listGeneMatch){
		int size = listGeneMatch.size();
		double sum = 0.0;
		for(int i = 0; i < size; i++){
			for(int j = i+1; j < size; j++){
				
			}
		}
		
		return 0;
	}
	
}
