package main;
import java.util.List;


public class GraphEntropy {

	
	
	public static double getComplexSomeValue(Complex complex, MatrixOfBioinfo mtx){
		double totalEntropy = 0.0;
		List<String> proteinList = complex.getProteinList();
		List<MatrixTitleRow> mtr = mtx.getTitleRow();
		for(String protein : proteinList){
			int cur = 0;
			int edgeNum = 0;
			int edgeInner = 0;
			for(MatrixTitleRow mtre : mtr){
				if(protein.equals(mtre.getName())){
					cur = mtre.getNum();
					break;
				}
			}
			for(int i = 0; i < mtx.size(); i++){
				if(cur != i && mtx.getElementValue(cur, i) > 0.0){
					edgeNum++;
					for(String pn : proteinList){
						if(mtr.get(i).getName().equals(pn)){
							edgeInner++;
							break;
						}
					}
				}
			}
			//System.out.println("ttttt" + edgeInner + "--" + edgeNum);
			double joinDegree = (0.0 + edgeInner) / (0.0 + proteinList.size() - 1.0);
			double indegree = (0.0 + edgeInner) / (0.0 + edgeNum);
			double someValue = joinDegree * indegree;
			totalEntropy += someValue;
		}
		return totalEntropy;
	}
	
	
	public static double getComplexEntropy(Complex complex, MatrixOfBioinfo mtx){
		double totalEntropy = 0.0;
		List<String> proteinList = complex.getProteinList();
		List<MatrixTitleRow> mtr = mtx.getTitleRow();
		for(String protein : proteinList){
			int cur = 0;
			int edgeNum = 0;
			int edgeInner = 0;
			for(MatrixTitleRow mtre : mtr){
				if(protein.equals(mtre.getName())){
					cur = mtre.getNum();
					break;
				}
			}
			for(int i = 0; i < mtx.size(); i++){
				if(cur != i && mtx.getElementValue(cur, i) > 0.0){
					edgeNum++;
					for(String pn : proteinList){
						if(mtr.get(i).getName().equals(pn)){
							edgeInner++;
							break;
						}
					}
				}
			}
			//System.out.println("ttttt" + edgeInner + "--" + edgeNum);
			double indegree = (0.0 + edgeInner) / (0.0 + edgeNum);
			totalEntropy += getGraphEntropy(indegree);
		}
		return totalEntropy;
	}
	
	public static double getGraphEntropy(double p){
		if(p > 0 && p < 1){
			double res;
			res = -(p * log(2, p) + (1 - p) * log(2, (1 - p)));
			return res;
		} else {
			return 0;
		}
	}
	
	public static double log(double base, double value){
		
		return Math.log(value) / Math.log(base);
		
	}
	public static double ln(double value){
		return Math.log(value);
	}
}
