package main;

public class MatrixElement {

	
	public MatrixElement(int r, int c, double v){
		row = r;
		col = c;
		value = v;
	}
	public MatrixElement(int r, int c){
		this(r,c,0.0);
	}
	public MatrixElement(MatrixElement m){
		this(m.getRow(),m.getCol(),m.getValue());
	}
	
	
	private int row;
	private int col;
	private double value;
	
	
	public double getValue(){
		return value;
	}
	public void setValue(double d){
		value = d;
	}
	public void setInfo(int row, int col, double value){
		this.row = row;
		this.col = col;
		this.value = value;
	}
	public int getRow(){
		return row;
	}
	public int getCol(){
		return col;
	}
	
	
	public static MatrixElement getElementByMultiply(MatrixOfBioinfo m1, MatrixOfBioinfo m2, int r, int c){
		double v = 0.0;
		for(int i = 0; i < m1.size(); i++){
			v += m1.getElement(r, i).getValue() * m2.getElement(i, c).getValue();
		}
		
		return new MatrixElement(r, c, v);
	}
	public MatrixElement getElementByMultiply(MatrixOfBioinfo m1, MatrixOfBioinfo m2){
		return getElementByMultiply(m1, m2, row, col);
	}
	
	
}
