package main;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;


public class Method1 {

	public static void main(String[] args) {


		String filePath  = "D:\\work\\webBio1\\code\\test1\\src\\file\\";
		String filePathPPI = filePath + "MIPS1.txt";
		String filePathComplexCYC = filePath + "complexN.txt";
		String filePathOldComplex = filePath + "complex1.txt";
		String filePathOut = filePath + "out" + new SimpleDateFormat("yyyyMMdd-hhmmss").format(new Date()) + ".txt";//for write
		String filePathMatrix = filePath + "matrix.txt";
		
		
		MatrixOfBioinfo mtxi = RuningMain.getMatrixByInit(filePathPPI).clearDiagonal();
		MatrixOfBioinfo mtx0 = new MatrixOfBioinfo(mtxi);
		List<MatrixOfBioinfo> lm = new ArrayList<MatrixOfBioinfo>();
		lm.add(mtx0);
		
		for(int i = 1; i < 5; i++){
			MatrixOfBioinfo m = lm.get(i-1).multiply(mtxi, 18);
			System.out.println("times :" + i);
			lm.add(m);
		}
		
		MatrixOfBioinfo mtx = new MatrixOfBioinfo(mtxi);
		for(int i = 1; i < lm.size(); i++){
			mtx = mtx.addition(lm.get(i));
		}
		
		double sum = 0.0;
		for(MatrixElement me : mtx.getElementList()){
			sum += me.getValue();
		}
		System.out.println("MyValue : " + sum);
		
		List<Complex> lcp1 = mtx.pruneForMethod1(0.00005).getComplexOld(3);
		List<Complex> lcp2 = mtx.pruneForMethod1(0.00005).getComplexOld(2);
		List<Complex> lcp3 = mtx.pruneForMethod1(0.00005).getComplexOld(1);
		
		List<Complex> lcm = RuningMain.getComplexCYC(filePathComplexCYC);
		
		RuningMain.writeComplexResult(filePath + "N1M3out" + new SimpleDateFormat("yyyyMMdd-hhmmss").format(new Date()) + ".txt", lcp3, lcm);
		RuningMain.writeComplexResult(filePath + "N1M2out" + new SimpleDateFormat("yyyyMMdd-hhmmss").format(new Date()) + ".txt", lcp2, lcm);
		RuningMain.writeComplexResult(filePath + "N1m1out" + new SimpleDateFormat("yyyyMMdd-hhmmss").format(new Date()) + ".txt", lcp1, lcm);
		
	}

}
