package main;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.ObjectInputStream.GetField;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;


public class RuningMain {

	public static void main(String[] args) {
		// TODO Auto-generated method stub
		
		String filePath  = "D:\\work\\webBio1\\code\\test1\\src\\file\\";
		String filePathPPI = filePath + "MIPS1.txt";
//		String filePathPPI = filePath + "coach\\ppi.txt";
		String filePathComplexCYC = filePath + "complexN.txt";
		String filePathOldComplex = filePath + "complex1.txt";
		String filePathOut = filePath + "out" + new SimpleDateFormat("yyyyMMdd-hhmmss").format(new Date()) + ".txt";//for write
		String filePathMatrix = filePath + "matrix.txt";
		
		
		MatrixOfBioinfo mtxi = getMatrixByInit(filePathPPI);
		MatrixOfBioinfo mtxG = mtxi.toECCMatrix().normalized();
//		MatrixOfBioinfo mtxG = mtxi.normalized();
		//MatrixOfBioinfo mtxG = getMatrixByFile(filePathMatrix);
		//MatrixOfBioinfo mtxG = testGene2.getGeneMatchValueMatrixList(mtxi, testGene.getMatchList(FilePath.filePathMatch)).get(0);
		MatrixOfBioinfo mtx = new MatrixOfBioinfo(mtxG);
		
		//mtx.showMatrix();
		
		int cur = 1;
		while(!mtx.isConverge() && cur < 2){
			
			mtx = mtx.multiply(mtxG, 18);
			
			mtx = mtx.inflation(2).pruneOfSigma(1).normalized();
//			mtx = mtx.inflation(2).normalized();
			//mtx.showMatrix();
			System.out.println("multiply time is " + cur++);//dddddddddddddddddddd
			//mtx.showMatrix();
		}
		//mtx.showMatrix();
		
		//List<Complex> lcp = mtx.getComplexNew(3);
		List<Complex> lcp3 = mtx.getComplexNew(3);
		List<Complex> lcp2 = mtx.getComplexNew(2);
		List<Complex> lcp1 = mtx.getComplexNew(1);
		List<Complex> lcp6 = mtx.getComplexOld(3);
		List<Complex> lcp5 = mtx.getComplexOld(2);
		List<Complex> lcp4 = mtx.getComplexOld(1);
		
		List<Complex> lcm = getComplexCYC(filePathComplexCYC);
		
		//-----------------------------------------------//
		
		writeComplexResult(filePath + lcp3.size() + "n3out" + new SimpleDateFormat("yyyyMMdd-hhmmss").format(new Date()) + ".txt", lcp3, lcm);
		writeComplexResult(filePath + "n2out" + new SimpleDateFormat("yyyyMMdd-hhmmss").format(new Date()) + ".txt", lcp2, lcm);
		//writeComplexResult(filePath + "n1out" + new SimpleDateFormat("yyyyMMdd-hhmmss").format(new Date()) + ".txt", lcp1, lcm);
		//writeComplexResult(filePath + "o3out" + new SimpleDateFormat("yyyyMMdd-hhmmss").format(new Date()) + ".txt", lcp6, lcm);
		//writeComplexResult(filePath + "o2out" + new SimpleDateFormat("yyyyMMdd-hhmmss").format(new Date()) + ".txt", lcp5, lcm);
		//writeComplexResult(filePath + "o1out" + new SimpleDateFormat("yyyyMMdd-hhmmss").format(new Date()) + ".txt", lcp4, lcm);
		System.out.println(cur);
		
		//8-03
		Complex.evaluateComplexList(lcp3, lcm, 0.2);
		Complex.evaluateComplexList(lcp2, lcm, 0.2);
		Complex.matchACC(lcp3, lcm);
		Complex.matchACC(lcp2, lcm);
		System.out.println("---80---50---");
		List<Complex> lcp3n = Complex.handleMethod1(lcp3, 80.0, 50.0);
		List<Complex> lcp2n = Complex.handleMethod1(lcp2, 80.0, 50.0);
		Complex.evaluateComplexList(lcp3n, lcm, 0.2);
		Complex.evaluateComplexList(lcp2n, lcm, 0.2);
		Complex.matchACC(lcp3n, lcm);
		Complex.matchACC(lcp2n, lcm);
		System.out.println("---80---50---2");
		List<Complex> lcp3n2 = Complex.handleMethod1(lcp3, 80.0, 50.0);
		List<Complex> lcp2n2 = Complex.handleMethod1(lcp2, 80.0, 50.0);
		Complex.evaluateComplexList(lcp3n2, lcm, 0.2);
		Complex.evaluateComplexList(lcp2n2, lcm, 0.2);
		Complex.matchACC(lcp3n2, lcm);
		Complex.matchACC(lcp2n2, lcm);
		
		//8-06
		double precise = 0.0;
		double recall = 0.0;
		double fvalue = 0.0;
		
		double precise2 = 0.0;
		double recall2 = 0.0;
		double fvalue2 = 0.0;
		
		for(Complex c : lcp3n){
			c.match(lcm);
			precise += c.getPrecise();
			recall += c.getRecall();
			fvalue += c.getPValue();
		}
		for(Complex c : lcp2n){
			c.match(lcm);
			precise2 += c.getPrecise();
			recall2 += c.getRecall();
			fvalue2 += c.getPValue();
		}
		System.out.println("----- 08 - 06 -----");
		System.out.println("lcp3 new -- p : " + precise/lcp3n.size() + " r : " + recall/lcp3n.size()
				+ " f : " + fvalue/lcp3n.size() + " size : " +lcp3n.size());
		System.out.println("lcp2 new -- p : " + precise2/lcp2n.size() + " r : " + recall2/lcp2n.size()
				+ " f : " + fvalue2/lcp2n.size() + " size : " +lcp2n.size());
		
		
	}
	
	
	public static MatrixOfBioinfo getMatrixByInit(String filePath1){
        List<EdgeElement> lst = new ArrayList<EdgeElement>();
		
		try {


            File file=new File(filePath1);

            if(file.isFile() && file.exists()){ //жļǷ

                InputStreamReader read = new InputStreamReader(

                new FileInputStream(file));//ǵʽ

                BufferedReader bufferedReader = new BufferedReader(read);

                String lineTxt = null;

                while((lineTxt = bufferedReader.readLine()) != null){
                	
                	//---------------------------------------------//
                    String[] str = lineTxt.split("	");
//                    String[] str = lineTxt.split(" ");
                    lst.add(new EdgeElement(str[0], str[1], 1));
                    //-----------------------------------------------//
                }

                read.close();

		    }else{
		
		        System.out.println("Ҳָļ");
		
		    }
		
		    } catch (Exception e) {
		
		        System.out.println("ȡļݳ");
		
		        e.printStackTrace();
		
		    }
			
		//------------------------------------------------------//
		return new MatrixOfBioinfo(lst);
	}
	
	public static MatrixOfBioinfo getMatrixByFile(String filePath){
		
		//------------------------------------------------------//
				MatrixOfBioinfo m = null;
				
				try {

		            File file=new File(filePath);

		            if(file.isFile() && file.exists()){ //жļǷ

		                InputStreamReader read = new InputStreamReader(

		                new FileInputStream(file));//ǵʽ

		                BufferedReader bufferedReader = new BufferedReader(read);

		                String lineTxt = null;
		                
		                //--------------//
		                int cnt = 0;
		                int row = 0;
	                	int size = 0;
                		List<MatrixTitleRow> lmtr = new ArrayList<MatrixTitleRow>();
                		List<MatrixElement> lme = new ArrayList<MatrixElement>();
                		//--------------//
		                while((lineTxt = bufferedReader.readLine()) != null){
		                	
		                	//---------------------------------------------//
		                	if(cnt == 0){
		                		size = new Integer(lineTxt);
		                		for(int i = 0; i < size*size; i++){
		                			lme.add(new MatrixElement(0, 0));
		                		}
		                	}else if(cnt == 1){
		                		int c = 0;
		                		for(String s : lineTxt.split("-")){
		                			lmtr.add(new MatrixTitleRow(c, s));
		                			c++;
		                		}
		                	}else if(cnt > 1){
		                		int col = 0;
		                		int cc= 0;//dddd
		                		for(String s : lineTxt.split(" ")){
		                			lme.get(MatrixOfBioinfo.getIndex(row, col, size)).setInfo(row, col, new Double(s));
		                			col++;
		                			if(new Double(s) > 0){ cc++; }//ddd
		                		}
		                		System.out.println("~~~"+row+"~~"+cc);//ddd
		                		row++;
		                	}else{
		                		System.out.println("some error");
		                	}
		                	
		                	cnt++;
		                    //-----------------------------------------------//
		                }
		                m = new MatrixOfBioinfo(size, lme, lmtr);
		                read.close();

				    }else{
				
				        System.out.println("Ҳָļ");
				
				    }
				
				    } catch (Exception e) {
				
				        System.out.println("ȡļݳ");
				
				        e.printStackTrace();
				
				    }
				
				
				//-----------------------------------------------//
				
				return m;
	}
	
	public static List<Complex> getComplexOld(String filePath){
		
		List<Complex> lcm = new ArrayList<Complex>();
		//------------------------------------------------------//
		
		try {


            File file=new File(filePath);

            if(file.isFile() && file.exists()){ //жļǷ

                InputStreamReader read = new InputStreamReader(

                new FileInputStream(file));//ǵʽ

                BufferedReader bufferedReader = new BufferedReader(read);

                String lineTxt = null;
                
                int cnt = 0;
                while((lineTxt = bufferedReader.readLine()) != null){
                	
                	//---------------------------------------------//
                	cnt++;
                    if(cnt%3 == 0){
                    	String[] str = lineTxt.split(",");
                    	Complex c = new Complex();
                    	for(String s : str){
                    		c.add(s);
                    	}
                    	lcm.add(c);
                    }
                    //-----------------------------------------------//
                }

                read.close();

		    }else{
		
		        System.out.println("Ҳָļ");
		
		    }
		
		    } catch (Exception e) {
		
		        System.out.println("ȡļݳ");
		
		        e.printStackTrace();
		
		    }
		
		
		//-----------------------------------------------//
		return lcm;
	}
	
	public static List<Complex> getComplexMy(String filePath){
		
		List<Complex> lcm = new ArrayList<Complex>();
		//------------------------------------------------------//
		
		try {


            File file=new File(filePath);

            if(file.isFile() && file.exists()){ //жļǷ

                InputStreamReader read = new InputStreamReader(

                new FileInputStream(file));//ǵʽ

                BufferedReader bufferedReader = new BufferedReader(read);

                String lineTxt = null;
                
                int cnt = 0;
                while((lineTxt = bufferedReader.readLine()) != null){
                	
                	//---------------------------------------------//
                	cnt++;
                    if(cnt%4 == 1){
                    	String[] str = lineTxt.split(" ");
                    	Complex c = new Complex();
                    	for(String s : str){
                    		c.add(s);
                    	}
                    	lcm.add(c);
                    }
                    //-----------------------------------------------//
                }

                read.close();

		    }else{
		
		        System.out.println("Ҳָļ");
		
		    }
		
		    } catch (Exception e) {
		
		        System.out.println("ȡļݳ");
		
		        e.printStackTrace();
		
		    }
		
		
		//-----------------------------------------------//
		return lcm;
	}
	
	public static List<Complex> getComplexCYC(String filePath){
		
		List<Complex> lcm = new ArrayList<Complex>();
		//------------------------------------------------------//
		
		try {


            File file=new File(filePath);

            if(file.isFile() && file.exists()){ //жļǷ

                InputStreamReader read = new InputStreamReader(

                new FileInputStream(file));//ǵʽ

                BufferedReader bufferedReader = new BufferedReader(read);

                String lineTxt = null;
                
                //complexѾ ¼ǰnameʶǷΪcomplex о
                String complexName = "----";
                Complex complex = new Complex();
                while((lineTxt = bufferedReader.readLine()) != null){
                	
                	//---------------------------------------------//
                	String str[] = lineTxt.split("	");
                	if(complexName.equals(str[2])){
                		complex.add(str[0]);
                	} else {
                		complexName = str[2];
                		if(complex.getProteinList().size() > 0){
                			lcm.add(complex);
                		}
                		complex = new Complex();
                		complex.add(str[0]);
                	}
                	
                    //-----------------------------------------------//
                }
                lcm.add(complex);
                //System.out.println(lcm.size());
                read.close();

		    }else{
		
		        System.out.println("Ҳָļ");
		
		    }
		
		    } catch (Exception e) {
		
		        System.out.println("ȡļݳ");
		
		        e.printStackTrace();
		
		    }
		
		
		//-----------------------------------------------//
        //System.out.println(lcm.size());
		return lcm;
	}
	
	public static List<Complex> getComplexCoAchResult(String filePath){
		
		List<Complex> lcm = new ArrayList<Complex>();
		//------------------------------------------------------//
		
		try {


            File file=new File(filePath);

            if(file.isFile() && file.exists()){ //жļǷ

                InputStreamReader read = new InputStreamReader(

                new FileInputStream(file));//ǵʽ

                BufferedReader bufferedReader = new BufferedReader(read);

                String lineTxt = null;
                
                int cnt = 0;
                int flg = 0;
                Complex c = new Complex();
                
                while((lineTxt = bufferedReader.readLine()) != null){
                	
                	//---------------------------------------------//
                	cnt++;
                    if( cnt%4 == 2){
                    	String[] str = lineTxt.split(":");
                    	String[] pre = str[1].split("  ");
                    	
                    	for(String s : pre){
                    		c.add(s);
                    	}
                    	
                    	flg = cnt;
                    	
                    	
                    }
                    
                    if(cnt % 4 == 3 && cnt == flg+1){
                    	String[] str = lineTxt.split(":");
                    	String[] pre = str[1].split("  ");
                    	
                    	for(String s : pre){
                    		c.add(s);
                    	}
                    	
                    	flg = cnt;
                    	lcm.add(c);
                    	c = new Complex();
                    }
                    //-----------------------------------------------//
                }
                //System.out.println(lcm.size());
                read.close();

		    }else{
		
		        System.out.println("Ҳָļ");
		
		    }
		
		    } catch (Exception e) {
		
		        System.out.println("ȡļݳ");
		
		        e.printStackTrace();
		
		    }
		
		
		//-----------------------------------------------//
        //System.out.println(lcm.size());
		return lcm;
	}
	
public static List<Complex> getComplexConeResult(String filePath){
		
		List<Complex> lcm = new ArrayList<Complex>();
		//------------------------------------------------------//
		
		try {


            File file=new File(filePath);

            if(file.isFile() && file.exists()){ //жļǷ

                InputStreamReader read = new InputStreamReader(

                new FileInputStream(file));//ǵʽ

                BufferedReader bufferedReader = new BufferedReader(read);

                String lineTxt = null;
                
                while((lineTxt = bufferedReader.readLine()) != null){
                	
                	//---------------------------------------------//
                	Complex c = new Complex();
                	String str[] = lineTxt.split(" ");
                	for(String s : str){
                		c.add(s);
                	}
                	lcm.add(c);
                	
                    //-----------------------------------------------//
                }
                //System.out.println(lcm.size());
                read.close();

		    }else{
		
		        System.out.println("Ҳָļ");
		
		    }
		
		    } catch (Exception e) {
		
		        System.out.println("ȡļݳ");
		
		        e.printStackTrace();
		
		    }
		
		
		//-----------------------------------------------//
        //System.out.println(lcm.size());
		return lcm;
	}
	
	
	public static void writeComplexResult(String filePathOut, List<Complex> lcp, List<Complex> lcm){
		
		//write
		File file = new File(filePathOut);
        FileWriter fw = null;
        BufferedWriter writer = null;
        try {
            fw = new FileWriter(file);
            writer = new BufferedWriter(fw);
            
            //*************//   1prodict 2match
    		double precise = 0.0;
    		double recall = 0.0;
    		double fvalue = 0.0;
    		double predictNum = 0.0;
    		double matchedNum = 0.0;
    		double trueNum = 0.0;
    		for(Complex c : lcp){
    			c.match(lcm);
    			precise += c.getPrecise();
    			recall += c.getRecall();
    			fvalue += c.getPValue();
    			predictNum += c.getPredictNum();
    			matchedNum += c.getMatchComplexNum();
    			trueNum = trueNum + c.getTruePositiveNum();
    			//System.out.println(c.getPrecise() + "==" + c.getRecall() + "==" + c.getPValue());
    			for(String s : c.getProteinList()){
    				writer.write(s + " ");
    			}
    			writer.newLine();
    			for(String s : c.getMatchedComplex().getProteinList()){
    				writer.write(s + " ");
    			}
    			writer.newLine();
    			writer.write("f-measure:" + c.getPValue() + " precise:" + c.getPrecise() + " recall:" + c.getRecall());
    			writer.newLine();
    			writer.newLine();
    		}
    		System.out.println("final " + fvalue/lcp.size() + "***" + precise/lcp.size() + "---" + recall/lcp.size()
    				              + "--" + lcp.size() + "**" + trueNum + "==" + predictNum + "==" + matchedNum);
            
            //*************//
            
            writer.flush();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }catch (IOException e) {
            e.printStackTrace();
        }finally{
            try {
                writer.close();
                fw.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
		
		//write end
	}
	
	
}
