package main;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashSet;
import java.util.List;
import java.util.Random;
import java.util.Set;

import util.*;

public class test {

	private static String filePath  = "D:\\work\\webBio1\\code\\test1\\src\\file\\";
	private static String filePathPPI = filePath + "MIPS1.txt";
	private static String filePathComplexCYC = filePath + "complexN.txt";
	private static String filePathOldComplex = filePath + "complex1.txt";
	private static String filePathOut = filePath + "out" + new SimpleDateFormat("yyyyMMdd-hhmmss").format(new Date()) + ".txt";//for write
	private static String filePathMatrix = filePath + "matrix.txt";

	
	public static void main(String[] args) {
		// TODO Auto-generated method stub

		//t4();
		//System.out.println(GraphEntropy.log(3, 81));
		//t1211();
		//tEntropy();
		
		//4-25
		//ComplexInfoStatistics c = new ComplexInfoStatistics();
		//c.doSomething();
		
		
		//4-26 ++
		String filePathN  = "D:\\work\\webBio1\\code\\test1\\src\\file\\evaModel\\05-09i.txt";
		List<GeneMatch> lgm = testGene.getMatchList(FilePath.filePathMatch);
		List<Complex> lcm = testGene.getComplexOld(filePathN);
		//List<Complex> lcm = RuningMain.getComplexCYC(FilePath.filePathComplexCYC);
		ComplexInfoStatistics.something(lcm, lgm);
		
		
		//6-29
		//tComplex();
	}
	
	private static void t1(){
		float i[][] = new float[5000][5000];
		Random ran = new Random();
		for(int j = 0; j < 5000; j++){
			for(int m = 0; m < 5000; m++){
				i[j][m] = ran.nextFloat();
			}
			
		}
		
		float k[][] = new float[5000][5000];
		for(int q=0; q<5000; q++){
			for(int w=0; w<5000; w++){
				float cnt = 0;
				for(int e=0; e<5000; e++){
					cnt += i[q][e] * i[e][w];
				}
				k[q][w] = cnt;
			}
			
			System.out.println("------" + q);
		}
		
		System.out.println(k[1000][1000]);
	}
	
	private static void t2(){
		List<MatrixElement> l = new ArrayList<MatrixElement>();
		for(int i = 0; i < 10000; i++){
			double d = 0.0;
			l.add(new MatrixElement(i/100, i%100, (i%100+d+1.0)/10000.0));
		}
		MatrixOfBioinfo m1 = new MatrixOfBioinfo(100, l, null);
		
		MatrixOfBioinfo m2 = new MatrixOfBioinfo(m1);
		//MatrixOfBioinfo m;
		for(int t = 0; t < 1000; t++){
			m1 = MatrixOfBioinfo.Multiply(m1, m2, 22).inflation(2).normalized().prune(0.001);
			if(m1.isConverge()){
				System.out.println(t+1);
				break;
			}
		}
		
		m1.showMatrix();
	}
	
	private static void t3(){
		
		MatrixOfBioinfo m = RuningMain.getMatrixByInit("D:\\eclipse\\code\\test1\\src\\file\\MIPS.txt");
		
		//write
		File file = new File("D:\\eclipse\\code\\test1\\src\\file\\matrix.txt");
        FileWriter fw = null;
        BufferedWriter writer = null;
        try {
            fw = new FileWriter(file);
            writer = new BufferedWriter(fw);
            
            //*************//
            writer.write("" + m.size());
            writer.newLine();
            
            for(MatrixTitleRow mtr : m.getTitleRow()){
            	writer.write(mtr.getName() + "-");
            }
            writer.newLine();
            
            List<MatrixElement> l = m.getElementList();
            for(int i = 0; i < m.size(); i++){
            	for(int j = 0; j < m.size(); j++){
            		String s = l.get(m.getIndex(i, j)).getValue() + " ";
            		writer.write(s);
            	}
            	writer.newLine();
            }
            
            
            //*************//
            
            writer.flush();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }catch (IOException e) {
            e.printStackTrace();
        }finally{
            try {
                writer.close();
                fw.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
		
		//write end
		
	}
	
	private static void t(){
		String str = "1-2-3-0-";
		int i = 0;
		double sum = 0.0;
		for(String s : str.split("-")){
			sum += java.lang.Math.pow(new Integer(s),2);
		}
		System.out.println(sum);
	}
	private static void t4(){
		Set<Integer> s = new HashSet<Integer>();
		s.add(1);
		s.add(2);
		s.add(4);
		s.add(1);
		s.add(3);
		for(int i : s){
			System.out.println(i);
		}
	}
	
	
	private static void t1211(){
		List<Complex> lc = RuningMain.getComplexCYC("D:\\work\\webBio1\\code\\test1\\src\\file\\complexN.txt");
		for(Complex c : lc){
			for(String s : c.getProteinList()){
				System.out.print(s + "---");
			}
			System.out.println();
		}
	}
	
	private static void tEntropy(){
		//List<Complex> lc = RuningMain.getComplexCYC("D:\\work\\webBio1\\code\\test1\\src\\file\\complexN.txt");
		List<Complex> lc = RuningMain.getComplexOld("D:\\work\\webBio1\\code\\test1\\src\\file\\complex2.txt");
		MatrixOfBioinfo mtxi = RuningMain.getMatrixByInit(filePathPPI);
		//MatrixOfBioinfo mtxG = mtxi.toECCMatrix().normalized();//.toECCMatrix().normalized()
		
		double sum = 0.0;
		for(Complex c : lc){
			//double ge = GraphEntropy.getComplexEntropy(c, mtxi);
			double ge = GraphEntropy.getComplexSomeValue(c, mtxi);
			sum += (ge / c.getProteinList().size());
			System.out.println(c.getProteinList().size() + "---" + ge + "===" + ge/c.getProteinList().size());
		}
		System.out.println("final avg: " + (sum/lc.size()));
	}
	
	private static void tComplex(){
		List<String> l = new ArrayList<String>();
		l.add("111");
		l.add("222");
		l.add("333");
		Complex c1 = new Complex(l);
		
		List<String> l2 = new ArrayList<String>();
		for(String s : l){
			l2.add(s);
		}
		l2.add("xxx");
		System.out.println(c1.getProteinList());
		System.out.println(l2);
		
	}
	
}
