package util;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashSet;
import java.util.List;
import java.util.Random;
import java.util.Set;

import main.Complex;
import main.MatrixOfBioinfo;

public class ComplexBuilderUtil {
	
	public ComplexBuilderUtil(MatrixOfBioinfo mtx, List<Complex> listOfComplex){
		mb = mtx;
		lc = listOfComplex;
		
		Set<String> set = new HashSet<String>();
		for(Complex c : lc){
			for(String pn : c.getProteinList()){
				set.add(pn);
			}
		}
		List<String> cycp = new ArrayList<String>();
		for(String p : set){
			cycp.add(p);
		}
		CYCProtein = cycp;
	}
	
	
	private Random r = new Random(new Date().getSeconds());
	private int mrxs = 3;
	
	private List<String> CYCProtein;
	
	private MatrixOfBioinfo mb;
	private List<Complex> lc;
	
	
	//---------------------------------------------------//
	private Complex getRandomComplex(){
		int cur = r.nextInt(lc.size());
		//System.out.println("+++++" + cur);
		return lc.get(cur);
	}
	private int getRandomComplexNum(){
		return getRandomComplex().getProteinList().size();
	}
	private int buildComplexNum(int n){
		int t = 0;
		
		for(int i = 0 ; i < n; i++){
			t += getRandomComplexNum();
		}
		//System.out.println(t + "-----------------");//
		return (t/n + 1);
		//return r.nextInt(2) > 1 ? (t/n + 1) : (t/n);
	}
	private int buildComplexNum(){
		return buildComplexNum(mrxs);
	}
	
	private int buildComplexNumByFluctuate(double p, int n){
		int init = buildComplexNum(n);
		if(r.nextFloat() < p){
			int r1 = getRandomComplexNum();
			int r2 = getRandomComplexNum();
			init = init * (r1 / r2);
		}
		
		return init;
	}
	private int buildComplexNumByFluctuate(double p){
		return buildComplexNumByFluctuate(p, mrxs);
	}
	//---------------------------------------------------//
	
	//---------------------------------------------------//
	private String getAllRandomProtein(){
		int n = r.nextInt(mb.getTitleRow().size());
		String s = mb.getTitleRow().get(n).getName();
		return s;
	}
	private String getCYCRandomProtein(){
		int n = r.nextInt(CYCProtein.size());
		String s = CYCProtein.get(n);
		return s;
	}
	private Complex getCYCAnyComplex(){
		int n = r.nextInt(lc.size());
		Complex c = lc.get(n);
		return c;
	}
	private int calNum(int num, double percent){
		double d = num * percent;
		int xia = (int)Math.floor(d);
		int shag = (int)Math.ceil(d);
		
		if(xia < 1){
			return shag;
		}
		
		if((xia + shag) > 2*d){
			return xia;
		} else {
			return shag;
		}
		
	}
	
	//---1---//
	public Complex getAllRandomComplex(int n){
		Set<String> set = new HashSet<String>();
		int num = buildComplexNum(n);
		for(int i = 0; i < num ; i++){
			set.add(getAllRandomProtein());
		}
		
		List<String> l = new ArrayList<String>();
		for(String s : set){
			l.add(s);
		}
		
		return new Complex(l);
	}
	public Complex getAllRandomComplex(){
		return getAllRandomComplex(mrxs);
	}
	public Complex getAllRandomComplex(double p, int n){
		Set<String> set = new HashSet<String>();
		int num = buildComplexNumByFluctuate(p, n);
		for(int i = 0; i < num ; i++){
			set.add(getAllRandomProtein());
		}
		
		List<String> l = new ArrayList<String>();
		for(String s : set){
			l.add(s);
		}
		
		return new Complex(l);
	}
	public Complex getAllRandomComplex(double p){
		return getAllRandomComplex(p, mrxs);
	}
	
	//---2---//
	public Complex getCYCRandomComplex(int n){
		Set<String> set = new HashSet<String>();
		int num = buildComplexNum(n);
		for(int i = 0; i < num ; i++){
			set.add(getCYCRandomProtein());
		}
		
		List<String> l = new ArrayList<String>();
		for(String s : set){
			l.add(s);
		}
		
		return new Complex(l);
	}
	public Complex getCYCRandomComplex(){
		return getCYCRandomComplex(mrxs);
	}
	public Complex getCYCRandomComplex(double p, int n){
		Set<String> set = new HashSet<String>();
		int num = buildComplexNumByFluctuate(p, n);
		for(int i = 0; i < num ; i++){
			set.add(getCYCRandomProtein());
		}
		
		List<String> l = new ArrayList<String>();
		for(String s : set){
			l.add(s);
		}
		
		return new Complex(l);
	}
	public Complex getCYCRandomComplex(double p){
		return getCYCRandomComplex(p, mrxs);
	}
	
	//---3---//
	public Complex getCYCandAllRandomComplex(double CYCrate, int n){
		Set<String> set = new HashSet<String>();
		int num = buildComplexNum(n);
		int numC = Math.round((float)(num * CYCrate));
		int numA = num - numC;
		
		for(int i = 0; i < numC ; i++){
			set.add(getCYCRandomProtein());
		}
		for(int i = 0; i < numA ; i++){
			set.add(getAllRandomProtein());
		}
		
		List<String> l = new ArrayList<String>();
		for(String s : set){
			l.add(s);
		}
		
		return new Complex(l);
	}
	public Complex getCYCandAllRandomComplex(double CYCrate){
		return getCYCandAllRandomComplex(CYCrate, mrxs);
	}
	
	public Complex getCYCandAllRandomComplex(double CYCrate, double p, int n){
		Set<String> set = new HashSet<String>();
		int num = buildComplexNumByFluctuate(p,n);
		int numC = Math.round((float)(num * CYCrate));
		int numA = num - numC;
		
		for(int i = 0; i < numC ; i++){
			set.add(getCYCRandomProtein());
		}
		for(int i = 0; i < numA ; i++){
			set.add(getAllRandomProtein());
		}
		
		List<String> l = new ArrayList<String>();
		for(String s : set){
			l.add(s);
		}
		
		return new Complex(l);
	}
	public Complex getCYCandAllRandomComplex(double CYCrate, double p){
		return getCYCandAllRandomComplex(CYCrate, p, mrxs);
	}
	
	//---4---//
	public Complex getAndRandomComplex(double trueRate){
		Set<String> set = new HashSet<String>();
		Complex c = getCYCAnyComplex();
		int cn = c.getProteinList().size();
		int num1 = calNum(cn, trueRate); 
		
		for(int i = 0; i < num1 ; i++){
			int rn = r.nextInt(cn);
			String s = c.getProteinList().get(rn);
			
			String s1 = getAllRandomProtein();//d
			set.add(s1);//d
			
			set.add(s);
		}
		
		List<String> l = new ArrayList<String>();
		for(String s : set){
			l.add(s);
		}
		
		return new Complex(l);
	}
	
	//---5---//
	public Complex getCYCAddRandomProtein(int addNum){
		
		List<String> l = new ArrayList<String>();
		
		for(String s : getCYCAnyComplex().getProteinList()){
			l.add(s);
		}
		
		for(int i = 0; i < addNum; ){
			String rp = getAllRandomProtein();
			for(String s : l){
				if(rp.equals(s)){
					continue;
				}
			}
			i++;
			l.add(rp);
		}
		
		return new Complex(l);
	}
	
	
	//other
	public List<String> getCYCProteinList(){
		return CYCProtein;
	}
	
}
