package main;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;


public class MatrixOfBioinfo {

	public MatrixOfBioinfo(int size, List<MatrixElement> elem, List<MatrixTitleRow> title){
		this.size = size;
		this.lst = new ArrayList<MatrixElement>();
		this.titleList = title;
		System.out.println(elem.size());
		for(MatrixElement e : elem){
			lst.add(new MatrixElement(e));
		}
		lst = elem;
	}
	public MatrixOfBioinfo(MatrixOfBioinfo m){
		this(m.size(), m.getElementList(), m.getTitleRow());
	}
	
	public MatrixOfBioinfo(List<EdgeElement> el){
		
		titleList = new ArrayList<MatrixTitleRow>();
		
		Set<String> set = new HashSet<>();
		
		for (EdgeElement e : el) {
			String e1 = e.getElement1();
			String e2 = e.getElement2();
			set.add(e1);
			set.add(e2);
		}
		Iterator<String> it = set.iterator();
		int sum = 0;
		while(it.hasNext()){
			sum++;
			String s = it.next();
			titleList.add(new MatrixTitleRow(sum-1, s));
		}
		size = sum;
		System.out.println("size is " + size);//dddddddddddddddddddddddddddddddddd
		lst = new ArrayList<MatrixElement>(size*size);
		for(int i = 0; i < size*size; i++){
			lst.add(new MatrixElement(0, 0));
		}
		//System.out.println("list size is " + lst.size());//dddddddddddddddddddddddddd
		//protein 1
		//int ccc = 0;
		for(MatrixTitleRow mtr : titleList){
			//int cccc = 0;
			List<String> ael = new ArrayList<String>();
			for(EdgeElement e : el){
				if(e.match(mtr.getName())){
					ael.add(e.getAnotherElement(mtr.getName()));
				}
				//System.out.println(e.getElement() + "---" + mtr.getName() + "+" +e.match(mtr.getName()));
			}
			for(String s : ael){
				for(int i = 0; i < size; i++){
					if(s.equals(titleList.get(i).getName())){
						lst.get(getIndex(mtr.getNum(), i)).setInfo(mtr.getNum(), i, 1);
						//cccc++;ccc++;//dd
					}
				}
			}
			//System.out.println("protein is "+mtr.getName()+"--"+mtr.getNum()+"++"+cccc+"**"+ccc);//ddddd
		}//end1
		//ǶԳ
		//for(int i = 0; i < size-1; i++){
		//	for(int j = i+1; j < size; j++){
		//		lst.get(getIndex(j, i)).setInfo(j, i, lst.get(getIndex(i, j)).getValue());
		//	}
		//}
		//ԽΪֵ
		for(int i = 0; i < size; i++){
			double max = 0;
			for(int j = 0; j < size; j++){
				if(lst.get(getIndex(i, j)).getValue() > max){
					max = lst.get(getIndex(i, j)).getValue();
				}
			}
			lst.get(getIndex(i, i)).setValue(max);
		}
		
		
	}
	
	
	private boolean flag;
	private int size;
	private List<MatrixElement> lst;
	private List<MatrixTitleRow> titleList;
	
	
	public int getIndex(int row, int col){
		
		return col + row*size;
	}
	public static int getIndex(int row, int col, int s){
		
		return col + row*s;
	}
	public List<MatrixTitleRow> getTitleRow(){
		return titleList;
	}
	public List<MatrixElement> getElementList(){
		return lst;
	}
	public MatrixElement getElement(int row, int col){
		return lst.get(getIndex(row, col));
	}
	public int size(){
		return size;
	}
	public MatrixOfBioinfo setDiagonalMax(){
		//ԽΪֵ
		for(int i = 0; i < size; i++){
			double max = 0;
			for(int j = 0; j < size; j++){
				if(i == j) { continue; }
				if(lst.get(getIndex(i, j)).getValue() > max){
					max = lst.get(getIndex(i, j)).getValue();
				}
			}
			if(max > 0){
				lst.get(getIndex(i, i)).setValue(max);
			}
		}
		return this;
	}
	
	public static MatrixOfBioinfo Multiply(MatrixOfBioinfo m1, MatrixOfBioinfo m2, int ThreadNum){
		List<MatrixElement> elem = new ArrayList<MatrixElement>();
		int sz = m1.size();
		//System.out.println("???");
		for(int l = 0; l < sz*sz; l++){
			//System.out.println(l);
			elem.add(new MatrixElement(0, 0));
		}
		//System.out.println("???1");
		boolean[] flagList = new boolean[ThreadNum];
		for(int s = 0; s < ThreadNum; s++){
			flagList[s] = false;
		}
		
		for(int i = 0; i < ThreadNum; i++){
			//System.out.println(i + "begin Thread");
			new MatrixMultiplyThread(i, ThreadNum, sz, m1, m2, elem, flagList).start();
		}
		
		int ct = 0;
		while(ct < ThreadNum){
			ct = 0;
			for(boolean b : flagList){
				if(b){ ct++; }
			}
		}
		
		return new MatrixOfBioinfo(m1.size(), elem, m1.getTitleRow());
	}
	public static MatrixOfBioinfo Multiply(MatrixOfBioinfo m1, MatrixOfBioinfo m2){
		List<MatrixElement> elem = new ArrayList<MatrixElement>();
		for(int i = 0; i < m1.size(); i++){
			for(int j = 0; j < m1.size(); j++){
				elem.add(MatrixElement.getElementByMultiply(m1, m2, i, j));
			}
		}
		return new MatrixOfBioinfo(m1.size(), elem, m1.getTitleRow());
	}
	public MatrixOfBioinfo multiply(MatrixOfBioinfo m){
		return Multiply(this, m);
	}
	public MatrixOfBioinfo multiply(MatrixOfBioinfo m, int ThreadNum){
		return Multiply(this, m, ThreadNum);
	}
	//һ 
	public static MatrixOfBioinfo Normalized(MatrixOfBioinfo m, double power){
		int size = m.size();
		for(int i = 0; i < size; i++){
			double sum = 0.0;
			for(int j = 0; j < size; j++){
				sum += java.lang.Math.pow(m.getElement(j, i).getValue(), power);
			}
			if(sum > 0){
				for(int j = 0; j < size; j++){
					double v = java.lang.Math.pow(m.getElement(j, i).getValue(), power) / sum;
					m.getElement(j, i).setValue(v);
				}
			}
		}
		
		return m;
	}
	public MatrixOfBioinfo normalized(){
		return MatrixOfBioinfo.Normalized(this, 1);
	}
	public MatrixOfBioinfo inflation(double r){
		return MatrixOfBioinfo.Normalized(this, r);
	}
	
	public static MatrixOfBioinfo Prune(MatrixOfBioinfo m, double th){
		int size = m.size();
		for(int i = 0; i < size; i++){
			for(int j = 0; j < size; j++){
				if(m.getElement(j, i).getValue() < th){
					m.getElement(j, i).setValue(0);
				}
			}
		}
		
		return m;
	}
	public MatrixOfBioinfo prune(double th){
		return MatrixOfBioinfo.Prune(this, th);
	}
	public MatrixOfBioinfo pruneOfSigma(double cishu){
		int sz = this.size;
		for(int i = 0; i < sz; i++){
			double th = calculateSigmaThreshold(cishu, i);
			for(int j = 0; j < sz; j++){
				if(getElement(j, i).getValue() < th){
					getElement(j, i).setValue(0);
				}
			}
		}
		return this;
	}
	private double calculateSigmaThreshold(double cishu, int column){
		double sum = 0.0;
		List<Double> ld = new ArrayList<Double>();
		for(int i = 0; i < size; i++){
			if(getElementValue(i, column) > 0.0){
				ld.add(getElementValue(i, column));
			}
		}
		for(double d : ld){
			sum += d;
		}
		double avg = sum / ld.size();
		if(cishu == 0){
			return avg;
		}
		sum = 0.0;
		for(double d : ld){
			sum += java.lang.Math.pow((d-avg), 2);
		}
		double fangcha = sum / ld.size();
		
		return (avg - fangcha*cishu);
	}
	
	public static MatrixOfBioinfo Addition(MatrixOfBioinfo m1, MatrixOfBioinfo m2){
		//֤߳
		
		List<MatrixElement> elem = new ArrayList<MatrixElement>();
		int sz = m1.size();
		for(int i = 0; i < sz; i++){
			for(int j = 0; j < sz; j++){
				double v = m1.getElementValue(i, j) + m2.getElementValue(i, j);
				elem.add(new MatrixElement(i, j, v));
			}
		}
		
		return new MatrixOfBioinfo(m1.size(), elem, m1.getTitleRow());
	}
	public MatrixOfBioinfo addition(MatrixOfBioinfo m){
		int sz = this.size();
		for(int i = 0; i < sz; i++){
			for(int j = 0; j < sz; j++){
				double v = m.getElementValue(i, j) + this.getElementValue(i, j);
				this.getElement(i, j).setValue(v);
			}
		}
		
		return this;
	}
	
	public boolean isConverge(){
		int count = 0;
		for(int i = 0; i < size; i++){
			int c = 0;
			for(int j = 0; j < size; j++){
				if(i != j &&  this.getElement(j, i).getValue() > 0){//////////////////// i != j
					c++;
				}
			}
			if(c <= 1){
				count++;
			}
		}
		return count == size;
	}
	
	public List<Complex> getComplexOld(int complexLimitNum){
		List<Complex> l = new ArrayList<Complex>();
		//
		for(int i = 0; i < size; i++){
			boolean f = false;//has element
			boolean b = false;//has self
			Complex c = new Complex();
			for(int j = 0; j < size; j++){
				if(lst.get(getIndex(i, j)).getValue() > 0){
					c.add(titleList.get(j).getName());
					f = true;
					if(i==j){ b = true; }
				}
			}
			if(f){
				if(!b){
					c.add(titleList.get(i).getName());
				}
				if(c.getProteinList().size() >= complexLimitNum){
					l.add(c);
				}
			}
		}
		
		return l;
	}
	public List<Complex> getComplexNew(int complexLimitNum){
		List<Complex> l = new ArrayList<Complex>();
		List<ComplexTemp> ltemp = new ArrayList<ComplexTemp>();
		//
		for(int i = 0; i < size; i++){
			boolean f = false;//has element
			boolean b = false;//has self
			Complex c = new Complex();
			for(int j = 0; j < size; j++){
				if(lst.get(getIndex(i, j)).getValue() > 0){
					c.add(titleList.get(j).getName());
					f = true;
					if(i==j){ b = true; }
				}
			}
			if(f){
				if(!b){
					ltemp.add(new ComplexTemp(titleList.get(i).getName(), c.getProteinList()));
				}
				if(c.getProteinList().size() >= complexLimitNum){
					l.add(c);
				}
			}
		}
		
		for(Complex c : l){
			Set<String> set = new HashSet<String>();
			List<String> plOld = c.getProteinList();
			for(ComplexTemp ct : ltemp){
				for(String pn : plOld){
					if(pn.equals(ct.getProteinName())){
						
						for(String s : c.getProteinList()){
							set.add(s);
						}
						for(String s : ct.getProteinList()){
							set.add(s);
						}
						
					}
				}
			}
			if(set.size() > plOld.size()){
				List<String> plNew = new ArrayList<String>();
				for(String s : set){
					plNew.add(s);
				}
				c.updateList(plNew);
			}
		}
		
		return l;
	}
	
	public double getElementValue(int row, int col){
		return lst.get(getIndex(row, col)).getValue();
	}
	public double getElementValue(String p1, String p2){
		int count = 0;
		int row = 0, col = 0;
		for(MatrixTitleRow mtr : this.titleList){
			if(mtr.getName().equals(p1) || mtr.getName().equals(p2)){
				count++;
				if(count == 1){
					row = mtr.getNum();
				} else if(count == 2){
					col = mtr.getNum();
					break;
				}
			}
		}
		
		return lst.get(getIndex(row, col)).getValue();
	}
	
	
	public static MatrixOfBioinfo getECCMatrix(MatrixOfBioinfo m){
		MatrixOfBioinfo mn = new MatrixOfBioinfo(m);
		List<MatrixTitleRow> lmtr = m.getTitleRow();
		for(int r = 0; r < m.size(); r++){
			for(int c = r; c < m.size(); c++){
				if(m.getElementValue(r, c) > 0.0){
					Set<Integer> set = new HashSet<Integer>();
					int sa = 0;
					int sb = 0;
					int sc = 0;
					for(int cur = 0; cur < m.size(); cur++){
						if(m.getElementValue(r, cur) > 0.0 && cur != c){
							set.add(cur);
							sa++;
						}
					}
					for(int cur = 0; cur < m.size(); cur++){
						if(m.getElementValue(c, cur) > 0.0 && cur != r){
							set.add(cur);
							sb++;
						}
					}
					sc = set.size();
					double jiao = 0.0 + sa + sb - sc;
					double bing = 1.0 + sc;//todo 86
					double ecc = jiao / bing;
					mn.getElement(r, c).setValue(ecc);
					mn.getElement(c, r).setValue(ecc);
				}
			}
			//mn.getElement(r, r).setValue(0);///////////
		}
		
		return mn;
	}
	public MatrixOfBioinfo toECCMatrix(){
		return MatrixOfBioinfo.getECCMatrix(this);
	}
	
	
	
	public MatrixOfBioinfo clearDiagonal(){
		for(int i = 0 ; i < size; i++){
			getElement(i, i).setValue(0);
		}
		return this;
	}
	
	//show
	public void showMatrix(){
		//for(MatrixTitleRow mtr : titleList){
		//	System.out.print(mtr.getName() + " ");
		//}
		//System.out.println();
		for(int i = 0; i < size; i++){
			for(int j = 0; j < size; j++){
				System.out.print(lst.get(getIndex(i, j)).getValue() + "-");
			}
			System.out.println();
		}
	}
	
	
	//////////////////////////////////
	public MatrixOfBioinfo pruneForMethod1(double cishu){
		double th = 0.0;
		double sum = 0.0;
		List<Double> ld = new ArrayList<Double>();
		for(MatrixElement me : lst){
			double d = me.getValue();
			if(d > 0.0){
				ld.add(d);
				sum += d;
			}
		}
		double avg = sum / ld.size();
		if(cishu != 0){
			sum = 0.0;
			for(double d : ld){
				sum += java.lang.Math.pow((d-avg), 2);
			}
			double fangcha = sum / ld.size();
			th = avg + fangcha*cishu;
		} else {
			th = avg;
		}
		
		for(MatrixElement me : lst){
			if(me.getValue() < th){
				me.setValue(0);
			}
		}
		return this;
	}
	
	
}
